#
# nginx.spec
#
%define  nginx_version    0.6.34
%define  rpm_epoch        1
%define  rpm_release      1qk

#%define  pcre_version     7.8
#%define  openssl_version  0.9.8i
#%define  zlib_version     1.2.3

# ----------------------------------------------------------------

Name: nginx
Version: %{nginx_version}
Epoch: %{rpm_epoch}
Summary: nginx web-server
Release: %{rpm_release}
Group: System Environment/Daemons
License: GPL
#Packager: Roman Shishnev <rommer@active.by>
Packager: Hyphen Wang<hyphenwang@redflag-linux.com>
#Vendor: Active Technologies, http://www.active.by/
Vendor: LinuxFly.org, http://www.linuxfly.org/
Source0: http://sysoev.ru/nginx/nginx-%{version}.tar.gz
#Source1: ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-%{pcre_version}.tar.gz
#Source2: http://www.openssl.org/source/openssl-%{openssl_version}.tar.gz
#Source3: http://www.zlib.net/zlib-%{zlib_version}.tar.gz
Source4: nginx.init
Source5: nginx.logrotate
Source6: nginx-rrd.pl
Source7: nginx-rrd.html
Prereq: /sbin/chkconfig /sbin/service /etc/init.d /etc/logrotate.d
BuildRoot: %{_tmppath}/%{name}-%{version}-root
#Patch0: nginx-0.5.0.1.patch

# disable debug package
%define  debug_package %{nil}
# disable stripping
#%define  __spec_install_post /usr/lib/rpm/brp-compress
#%define  __os_install_post /usr/lib/rpm/brp-compress

%description
high perfomance http and reverse proxy server

%package rrd
Summary: creating stats graph for nginx
Group: System Environment/Daemons
Requires: %{name} = %{epoch}:%{version}

%description rrd
creating stats graph for nginx

#%package debug
#Summary: debug information for package nginx
#Group: Development/Debug
#Requires: %{name} = %{epoch}:%{version}

#%description debug
#this package provides non-stripped nginx binary compiled
#with --with-debug option

%package contrib
Summary: contrib directory for package nginx
Group: System Environment/Daemons
Requires: %{name} = %{epoch}:%{version}

%description contrib
this package provides contrib directory from nginx sources

%prep 
%setup -q
#%patch0 -p0

%build
# usage: BuildNginx <binaryname> <options>
BuildNginx() {
    # unpack libraries
#    tar zxf ${RPM_SOURCE_DIR}/pcre-%{pcre_version}.tar.gz
#    tar zxf ${RPM_SOURCE_DIR}/openssl-%{openssl_version}.tar.gz
#    tar zxf ${RPM_SOURCE_DIR}/zlib-%{zlib_version}.tar.gz

    # configure nginx
    ./configure \
	--prefix=/usr/local/nginx \
	--with-cpu-opt=pentiumpro \
	--http-proxy-temp-path=/usr/local/nginx/tmp/proxy \
	--http-fastcgi-temp-path=/usr/local/nginx/tmp/fastcgi \
	--http-client-body-temp-path=/usr/local/nginx/tmp/client-body \
	--with-http_ssl_module \
	--with-http_flv_module \
	--with-http_stub_status_module \
#	--with-pcre=pcre-%{pcre_version} \
#	--with-zlib=zlib-%{zlib_version} \
#	--with-openssl=openssl-%{openssl_version} \
	$2


    # and make it
    make -s

    # save binary
    cp objs/nginx $1

    # do make clean
    make clean
#    rm -rf pcre-%{pcre_version}/
#    rm -rf openssl-%{openssl_version}/
#    rm -rf zlib-%{zlib_version}/
}

# do it ...
BuildNginx nginx
#BuildNginx nginx.debug "--with-debug"

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
mkdir -p ${RPM_BUILD_ROOT}/etc/logrotate.d
mkdir -p ${RPM_BUILD_ROOT}/usr/local/nginx/bin
mkdir -p ${RPM_BUILD_ROOT}/usr/local/nginx/sbin
mkdir -p ${RPM_BUILD_ROOT}/usr/local/nginx/conf
mkdir -p ${RPM_BUILD_ROOT}/usr/local/nginx/html/stat/img
mkdir -p ${RPM_BUILD_ROOT}/usr/local/nginx/html/stat/rrd
mkdir -p ${RPM_BUILD_ROOT}/usr/local/nginx/tmp
mkdir -p ${RPM_BUILD_ROOT}/var/log/nginx
ln -s ../usr/local/nginx/conf ${RPM_BUILD_ROOT}/etc/nginx
ln -s ../../../var/log/nginx ${RPM_BUILD_ROOT}/usr/local/nginx/logs
install -m 644 conf/koi-win ${RPM_BUILD_ROOT}/usr/local/nginx/conf/koi-win
install -m 644 conf/koi-utf ${RPM_BUILD_ROOT}/usr/local/nginx/conf/koi-utf
install -m 644 conf/win-utf ${RPM_BUILD_ROOT}/usr/local/nginx/conf/win-utf
install -m 644 conf/fastcgi_params ${RPM_BUILD_ROOT}/usr/local/nginx/conf/fastcgi_params
install -m 644 conf/mime.types ${RPM_BUILD_ROOT}/usr/local/nginx/conf/mime.types
install -m 644 conf/mime.types ${RPM_BUILD_ROOT}/usr/local/nginx/conf/mime.types.default
install -m 644 conf/nginx.conf ${RPM_BUILD_ROOT}/usr/local/nginx/conf/nginx.conf
install -m 644 conf/nginx.conf ${RPM_BUILD_ROOT}/usr/local/nginx/conf/nginx.conf.default
install -m 644 html/index.html ${RPM_BUILD_ROOT}/usr/local/nginx/html/index.html
install -m 644 html/50x.html ${RPM_BUILD_ROOT}/usr/local/nginx/html/50x.html
install -m 755 ${RPM_SOURCE_DIR}/nginx-rrd.pl ${RPM_BUILD_ROOT}/usr/local/nginx/bin/nginx-rrd.pl
install -m 644 ${RPM_SOURCE_DIR}/nginx-rrd.html ${RPM_BUILD_ROOT}/usr/local/nginx/html/stat/index.html
install -m 755 ${RPM_SOURCE_DIR}/nginx.init ${RPM_BUILD_ROOT}/etc/init.d/nginx
install -m 644 ${RPM_SOURCE_DIR}/nginx.logrotate ${RPM_BUILD_ROOT}/etc/logrotate.d/nginx
#install -m 755 nginx.debug ${RPM_BUILD_ROOT}/usr/local/nginx/sbin/nginx.debug
install -m 755 nginx ${RPM_BUILD_ROOT}/usr/local/nginx/sbin/nginx
strip ${RPM_BUILD_ROOT}/usr/local/nginx/sbin/nginx
cp -pr contrib ${RPM_BUILD_ROOT}/usr/local/nginx/contrib

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
if [ -d /usr/local/nginx/logs -a ! -h /usr/local/nginx/logs ]; then
    mv /usr/local/nginx/logs /usr/local/nginx/logs.rpmsave
fi

%post
/sbin/chkconfig --add nginx
/sbin/chkconfig nginx on
exit 0

%preun
if [ $1 = 0 ]; then
    /sbin/chkconfig --del nginx
fi

%files
%defattr(-,root,root)
%doc README CHANGES CHANGES.ru LICENSE
%config(noreplace) /usr/local/nginx/conf/mime.types
%config(noreplace) /usr/local/nginx/conf/nginx.conf
/etc/init.d/nginx
/etc/logrotate.d/nginx
/usr/local/nginx/sbin/nginx
/usr/local/nginx/conf/koi-win
/usr/local/nginx/conf/koi-utf
/usr/local/nginx/conf/win-utf
/usr/local/nginx/conf/fastcgi_params
/usr/local/nginx/conf/nginx.conf.default
/usr/local/nginx/conf/mime.types.default
/usr/local/nginx/html/index.html
/usr/local/nginx/html/50x.html
/usr/local/nginx/logs
/var/log/nginx
/etc/nginx
%attr(0700,nobody,root) /usr/local/nginx/tmp

%files rrd
%defattr(-,root,root)
/usr/local/nginx/bin/nginx-rrd.pl
/usr/local/nginx/html/stat/index.html
/usr/local/nginx/html/stat/img
/usr/local/nginx/html/stat/rrd

#%files debug
#%defattr(-,root,root)
#/usr/local/nginx/sbin/nginx.debug

%files contrib
%defattr(-,root,root)
/usr/local/nginx/contrib/*

%changelog
* Tue Dec 23 2008 HyphenWang<hyphenwang@redflag-linux.com> 0.6.34-1qk
- Build in RedFlag Asianux 3.0

* Fri Dec 19 2008 <rommer@active.by> 0.6.34-1
- rpm update from 0.5.x versions fix

* Mon Dec  1 2008 <rommer@active.by> 0.6.34-0
- 0.6.x tree migration:
  new nginx version - 0.6.34
- update openssl to 0.9.8i
- updated pcre to 7.8
- symlink /usr/local/nginx/logs -> /var/log/nginx
- symlink /etc/nginx -> /usr/local/nginx/conf
- build with --with-cpu-opt=pentiumpro

* Mon Apr  7 2008 <ivy@active.by> 0.5.35-1
- new nginx version - 0.5.35 with http_flv_module

* Sat Feb 16 2008 <rommer@active.by> 0.5.35-0
- new nginx version - 0.5.35
- updated openssl to 0.9.8g
- updated pcre to 7.6

* Mon Sep 24 2007 <rommer@active.by> 0.5.32-0
- new nginx version - 0.5.32

* Wed Aug  1 2007 <rommer@active.by> 0.5.30-0
- new nginx version - 0.5.30

* Tue Jul 24 2007 <rommer@active.by> 0.5.29-0
- new nginx version - 0.5.29

* Fri Jul 13 2007 <rommer@active.by> 0.5.27-0
- new nginx version - 0.5.27

* Wed May 23 2007 <rommer@active.by> 0.5.20-0
- new nginx version - 0.5.20

* Thu Apr 26 2007 <rommer@active.by> 0.5.19-0
- new nginx version - 0.5.19
- new pcre version - 7.1

* Sat Apr  7 2007 <rommer@active.by> 0.5.17-0
- new nginx version - 0.5.17

* Thu Mar 29 2007 <rommer@active.by> 0.5.16-0
- new nginx version - 0.5.16

* Thu Mar 22 2007 <rommer@active.by> 0.5.15-0
- rebuild

* Fri Mar 16 2007 <rommer@active.by> 0.5.14-0
- rebuild
- updated openssl to 0.9.8e

* Thu Feb 22 2007 <rommer@active.by> 0.5.13-0
- rebuild

* Mon Feb 12 2007 <rommer@active.by> 0.5.12-0
- rebuild

* Tue Jan 30 2007 <rommer@active.by>
- new nginx version - 0.5.10

* Mon Jan 22 2007 <rommer@active.by>
- new nginx version - 0.5.8

* Thu Jan 11 2007 <rommer@active.by>
- new nginx version - 0.5.6

* Fri Dec 15 2006 <rommer@active.by>
- new nginx version - 0.5.4

* Tue Dec 12 2006 <rommer@active.by>
- new nginx version - 0.5.2

* Mon Nov 27 2006 <rommer@active.by>
- new nginx version - 0.4.14

* Wed Nov 22 2006 <rommer@active.by>
- new nginx version - 0.4.13

* Sat Oct 28 2006 <rommer@active.by>
- new nginx version - 0.4.11

* Tue Oct 24 2006 <rommer@active.by>
- new nginx version - 0.4.10

* Tue Oct 17 2006 <rommer@active.by>
- nginx-0.4.9.1.patch
  relocated temp-paths

* Mon Oct 16 2006 <rommer@active.by>
- new nginx version - 0.4.9

* Mon Oct 09 2006 <rommer@active.by>
- new nginx version - 0.4.6

* Wed Oct 04 2006 <rommer@active.by>
- new nginx version - 0.4.5 +
  nginx-0.4.5.1.patch
- new openssl version 0.9.8d

* Tue Sep 26 2006 <rommer@active.by>
- new nginx version - 0.4.3

* Thu Sep 14 2006 <rommer@active.by>
- new nginx version - 0.4.2
- new openssl version 0.9.8c

* Thu Aug 31 2006 <rommer@active.by>
- new nginx version - 0.4.0

* Tue Aug 29 2006 <rommer@active.by>
- new nginx version - 0.3.61
- now nginx-debug package contains non-stripped nginx binary
  compiled with the "--with-debug" option

* Mon Aug 28 2006 <rommer@active.by>
- new nginx version - 0.3.60

* Fri Aug 04 2006 <rommer@active.by>
- new nginx version - 0.3.56
- added package and vendor tags
- added contrib package

* Sat Jul 29 2006 <rommer@active.by>
- new nginx version - 0.3.55

* Wed Jul 19 2006 <rommer@active.by>
- add requires for rrd and debug packages

* Tue Jul 18 2006 <rommer@active.by>
- new nginx version - 0.3.54
- added debug package with non-stripped nginx binary

* Wed Jul 05 2006 <rommer@active.by>
- new nginx version - 0.3.52

* Tue Jun 20 2006 <rommer@active.by>
- patch-0.3.49.1, new nginx-rrd.pl (new package)

* Mon Jun 05 2006 <rommer@active.by>
- configure with "--with-http_stub_status_module"
- nginx-rrd.pl, nginx-rrd.html

* Thu Jun 01 2006 <rommer@active.by>
- new nginx version - 0.3.49

* Tue May 30 2006 <rommer@active.by>
- new nginx version - 0.3.48.1 (nginx-0.3.48 + patch-0.3.48.1)

* Wed May 24 2006 <rommer@active.by>
- new nginx version - 0.3.47

* Mon Apr 24 2006 <rommer@active.by>
- use zlib-1.2.3 from sources

* Fri Apr 21 2006 <aleh@active.by>, <rommer@active.by>
- First release
